=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2008-06-16 08:49:28 +0000
+++ loggerhead/controllers/changelog_ui.py	2008-06-18 04:29:01 +0000
@@ -57,7 +57,6 @@
             try:
                 revid, start_revid, revid_list = h.get_view(
                     revid, start_revid, filter_file_id, query)
-                kw['start_revid'] = start_revid
                 util.set_context(kw)
 
                 if (query is not None) and (len(revid_list) == 0):
@@ -101,9 +100,6 @@
                         all_same_author = False
                         break
 
-            def url(pathargs, **kw):
-                return self._branch.url(pathargs, **util.get_context(**kw))
-
             vals = {
                 'branch': self._branch,
                 'changes': changes,

=== modified file 'loggerhead/controllers/revision_ui.py'
--- loggerhead/controllers/revision_ui.py	2008-06-16 08:49:28 +0000
+++ loggerhead/controllers/revision_ui.py	2008-06-18 09:02:55 +0000
@@ -54,8 +54,8 @@
             filter_file_id = kw.get('filter_file_id', None)
             start_revid = h.fix_revid(kw.get('start_revid', None))
             query = kw.get('q', None)
-            remember = kw.get('remember', None)
-            compare_revid = kw.get('compare_revid', None)
+            remember = h.fix_revid(kw.get('remember', None))
+            compare_revid = h.fix_revid(kw.get('compare_revid', None))
 
             try:
                 revid, start_revid, revid_list = h.get_view(revid, start_revid, filter_file_id, query)

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2008-06-16 09:48:20 +0000
+++ loggerhead/history.py	2008-06-19 23:02:48 +0000
@@ -288,7 +288,6 @@
     def get_config(self):
         return self._branch.get_config()
 
-
     def get_revno(self, revid):
         if revid not in self._revision_info:
             # ghost parent?
@@ -606,6 +605,7 @@
     @with_branch_lock
     @with_bzrlib_read_lock
     def get_changes_uncached(self, revid_list):
+        # FIXME: deprecated method in getting a null revision
         revid_list = filter(lambda revid: not bzrlib.revision.is_null(revid),
                             revid_list)
         parent_map = self._branch.repository.get_graph().get_parent_map(revid_list)

=== modified file 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/annotate.pt	2008-05-29 04:43:39 +0000
+++ loggerhead/templates/annotate.pt	2008-06-18 04:20:32 +0000
@@ -5,48 +5,35 @@
     <title metal:fill-slot="title"
            tal:content="string:${branch/friendly_name} : contents of ${path}
                         at revision ${change/revno}">
-      ${branch.friendly_name} : contents of ${path} at revision ${change.revno}
     </title>
   </head>
 
   <body>
 
     <h1 metal:fill-slot="heading">
-      <span class="branch-name" tal:content="branch/friendly_name">
-        ${branch.friendly_name}
-      </span>
+      <span class="branch-name" tal:content="branch/friendly_name"></span>
       :
-      <span class="annotate-path" tal:content="path">
-        ${path}
-      </span>
-      (revision <tal:revno content="change/revno">${change.revno}</tal:revno>)
+      <span class="annotate-path" tal:content="path"></span>
+      (revision <tal:revno content="change/revno"></tal:revno>)
     </h1>
 
     <div metal:fill-slot="content">
       <div class="links">
         <div>
           <b>&#8594;</b>
-          <a tal:attributes="href python:url(['/files', revid], clear=1)">
-            browse files
-          </a>
-        </div>
-        <div>
-          <b>&#8594;</b>
-          <a tal:attributes="href python:url(['/revision'], clear=1, start_revid=revid)">
-            view revision
-          </a>
-        </div>
-        <div>
-          <b>&#8594;</b>
-          <a tal:attributes="href python:url(['/changes'], clear=1, start_revid=revid, filter_file_id=file_id)">
-            view changes to this file
-          </a>
-        </div>
-        <div>
-          <b>&#8594;</b>
-          <a tal:attributes="href python:url(['/download', revid, file_id, filename])">
-            download file
-          </a>
+          <a tal:attributes="href python:url(['/files', change.revno], clear=1)">browse files</a>
+        </div>
+        <div>
+          <b>&#8594;</b>
+          <a tal:attributes="href python:url(['/revision'], clear=1, start_revid=change.revno)">view revision</a>
+        </div>
+        <div>
+          <b>&#8594;</b>
+          <a tal:attributes="href python:url(['/changes'], clear=1, start_revid=change.revno, filter_file_id=file_id)">view changes to this file</a>
+        </div>
+        <div>
+          <b>&#8594;</b>
+          <a tal:attributes="href python:url(['/download', change.revno, file_id, filename])">download file</a>
         </div>
       </div>
 
@@ -62,22 +49,16 @@
               tal:attributes="class string:parity${line/parity}">
             <td tal:attributes="class string:lineno ${line/status}">
               <a tal:attributes="name string:L${line/lineno}"
-                 tal:content="line/lineno">
-                ${line.lineno}
-              </a>
+                 tal:content="line/lineno"></a>
             </td>
             <td tal:attributes="class string:revno ${line/status}">
               <a tal:condition="python:line.status=='changed'"
                  tal:content="python:util.trunc(line.change.revno)"
-                 tal:attributes="href python:url(['/revision'], clear=1, start_revid=line.change.revid, filter_file_id=file_id);
-                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, util.hide_email(line.change.author), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))">
-
-                ${util.trunc(line.change.revno)}
-              </a>
+                 tal:attributes="href python:url(['/revision'], clear=1, start_revid=line.change.revno, filter_file_id=file_id);
+                                 title python:'%s by %s, on %s (%s)'%(line.change.revno, util.hide_email(line.change.author), line.change.date.strftime('%d %b %Y %H:%M'), util.date_time(line.change.date))"></a>
             </td>
             <td tal:attributes="class string:text ${line/status}"
                 tal:content="line/text">
-              ${line.text}
             </td>
           </tr>
         </table>

=== modified file 'loggerhead/templates/atom.pt'
--- loggerhead/templates/atom.pt	2008-06-10 04:48:26 +0000
+++ loggerhead/templates/atom.pt	2008-06-11 04:41:08 +0000
@@ -14,7 +14,7 @@
     <updated tal:content="entry/date/isoformat">
     Z
     </updated>
-    <id tal:content="python:branch.url(['revision', entry.revid])">
+    <id tal:content="python:branch.url(['revision', entry.revno])">
       ID
     </id>
     <author>
@@ -26,6 +26,6 @@
       comment
     </content>
     <link rel="alternate"
-          tal:attributes="href python:branch.url(['revision', entry.revid])" />
+          tal:attributes="href python:branch.url(['revision', entry.revno])" />
   </entry>
 </feed>

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2008-06-11 04:51:53 +0000
+++ loggerhead/templates/changelog.pt	2008-06-19 23:02:48 +0000
@@ -77,8 +77,8 @@
             <a tal:attributes="name string:entry-${entry/revno}" />
             <tr tal:attributes="class string:revision-header parity${entry/parity}">
               <td class="revision-number">
-                <a tal:attributes="title python:'Show revision '+history.get_revno(entry.revid);
-                                   href  python:url(['/revision', entry.revid])"
+                <a tal:attributes="title python:'Show revision '+entry.revno;
+                                   href  python:url(['/revision', entry.revno])"
                    tal:content="python:util.trunc(entry.revno)">
                   text
                 </a>
@@ -87,8 +87,8 @@
                   tal:content="structure python:collapse_button('cl', entry.revno)">
               </td>
               <td class="summary">
-                <a tal:attributes="title python:'Show revision '+history.get_revno(entry.revid);
-                                   href  python:url(['/revision', entry.revid])"
+                <a tal:attributes="title python:'Show revision '+entry.revno;
+                                   href  python:url(['/revision', entry.revno])"
                    tal:content="entry/short_comment">
                   text
                 </a>
@@ -101,7 +101,7 @@
                         tal:content="python:util._approximatedate(entry.date)"></span>
               </td>
               <td class="inventory-link">
-                <a tal:attributes="href python:branch.url(['/files', entry.revid]);
+                <a tal:attributes="href python:branch.url(['/files', entry.revno]);
                                    title string:Files at revision ${entry/revno}">
                   files
                 </a>
@@ -121,7 +121,7 @@
                     </th>
                     <td class="children">
                       <a title="Show history"
-                         tal:attributes="href python:url(['/changes'], start_revid=merge_point.revid)"
+                         tal:attributes="href python:url(['/changes'], start_revid=merge_point.revno)"
                          tal:content="python:revno_with_nick(merge_point)">
                         class="revlink">
                         ${text}
@@ -136,7 +136,7 @@
                     </th>
                     <td class="parents">
                       <a title="Show history"
-                         tal:attributes="href python:url(['/changes'], start_revid=parent.revid)"
+                         tal:attributes="href python:url(['/changes'], start_revid=parent.revno)"
                          tal:content="python:revno_with_nick(parent)">
                         class="revlink">
                         ${text}

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2008-06-11 04:53:47 +0000
+++ loggerhead/templates/inventory.pt	2008-06-20 02:13:34 +0000
@@ -20,10 +20,10 @@
 
     <div metal:fill-slot="content">
       <div class="links">
-        <div> <b>&#8594;</b> <a tal:attributes="href python:url(['/revision'], clear=1, start_revid=revid)">
+        <div> <b>&#8594;</b> <a tal:attributes="href python:url(['/revision', change.revno], clear=1, start_revid=change.revno)">
 	    view revision </a>
         </div>
-        <div> <b>&#8594;</b> <a tal:attributes="href python:url(['/changes'], clear=1, start_revid=revid)">
+        <div> <b>&#8594;</b> <a tal:attributes="href python:url(['/changes', change.revno], clear=1, start_revid=change.revno)">
 	    view branch changes </a>
         </div>
       </div>
@@ -81,7 +81,7 @@
           </td>
           <td tal:attributes="class string:filename ${file/kind}">
             <a tal:condition="python:file.kind=='directory'"
-               tal:attributes="href python:url(['/files', revid], file_id=file.file_id)"
+               tal:attributes="href python:url(['/files', change.revno], file_id=file.file_id)"
                tal:content="string:${file/filename}/">
               ${file.filename}/
             </a>
@@ -90,14 +90,14 @@
               ${file.filename}@
             </span>
             <a tal:condition="python:file.kind=='file'"
-               tal:attributes="href python:url(['/annotate', revid], file_id=file.file_id);
+               tal:attributes="href python:url(['/annotate', change.revno], file_id=file.file_id);
                                title string:Annotate ${file/filename}"
                tal:content="string:${file/filename}">
               ${file.filename}
             </a>
           </td>
           <td class="revision">
-            <a tal:attributes="href python:url(['/revision', file.revid], start_revid=file.revid, file_id=file.file_id);
+            <a tal:attributes="href python:url(['/revision', file.change.revno], filter_file_id=file.file_id);
                                title string:Show revision ${file/change/revno}"
                tal:content="python:util.trunc(file.change.revno, 15)">
               ${text}

=== modified file 'loggerhead/templates/modified-file-link-log.pt'
--- loggerhead/templates/modified-file-link-log.pt	2008-06-11 02:19:53 +0000
+++ loggerhead/templates/modified-file-link-log.pt	2008-06-19 23:02:48 +0000
@@ -1,5 +1,5 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<a tal:attributes="href python:'javascript:diff_url(\'' + url(['/revision', entry.revid]) + '#' + item.filename + '\')';
+<a tal:attributes="href python:'javascript:diff_url(\'' + url(['/revision', entry.revno]) + '#' + item.filename + '\')';
                    title string:Annotate ${item/filename}"
    tal:content="item/filename" class="filename">
   item/filename

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2008-06-11 03:17:41 +0000
+++ loggerhead/templates/revision.pt	2008-06-19 23:02:48 +0000
@@ -33,44 +33,44 @@
         <div class="links">
           <div>
             <b>&#8594;</b>
-            <a tal:attributes="href python:url(['/files', revid])">
+            <a tal:attributes="href python:url(['/files', change.revno])">
               browse files at revision <tal:b content="change/revno" />
             </a>
           </div>
           <div>
             <b>&#8594;</b>
-            <a tal:attributes="href python:url(['/changes'], start_revid=revid)">
+            <a tal:attributes="href python:url(['/changes'], start_revid=change.revno)">
               view history from revision <tal:b content="change/revno" />
             </a>
           </div>
           <div tal:condition="python:compare_revid is not None" >
             <b>&#8594;</b>
-            <a tal:attributes="href python:branch.url(['/bundle', revid, compare_revid, 'bundle.txt'])">
+            <a tal:attributes="href python:branch.url(['/bundle', change.revno, history.get_revno(compare_revid), 'bundle.txt'])">
                 download bundle from <tal:b content="python:history.get_revno(compare_revid)" /> to <tal:b content="change/revno" />
             </a>
           </div>
-          <div tal:condition="python:(remember is not None) and (compare_revid is None) and (revid != remember)" >
+          <div tal:condition="python:(remember is not None) and (compare_revid is None) and remember != revid" >
             <b>&#8594;</b>
-            <a tal:attributes="href python:url(['/revision', revid], compare_revid=remember)">
+            <a tal:attributes="href python:url(['/revision', change.revno], compare_revid=history.get_revno(remember))">
               compare with revision <tal:b content="python:history.get_revno(remember)" />
             </a>
           </div>
           <div  tal:condition="python:remember != revid">
             <b>&#8594;</b>
-            <a tal:attributes="href python:url(['/revision', revid], remember=revid, compare_revid=None)">
+            <a tal:attributes="href python:url(['/revision', change.revno], remember=change.revno, compare_revid=None)">
               compare with another revision
             </a>
           </div>
           <tal:we-are-comparing condition="python:compare_revid is not None">
             <div>
               <b>&#8594;</b>
-              <a tal:attributes="href python:url([ '/revision', compare_revid ], remember=revid, compare_revid=revid)">
+              <a tal:attributes="href python:url([ '/revision', history.get_revno(compare_revid) ], remember=change.revno, compare_revid=change.revno)">
                 reverse the comparison (<tal:b content="change/revno" /> to <tal:b content="python:history.get_revno(compare_revid)" />)
               </a>
             </div>
             <div>
               <b>&#8594;</b>
-              <a tal:attributes="href python:url(['/revision', revid], remember=None, compare_revid=None)">
+              <a tal:attributes="href python:url(['/revision', change.revno], remember=None, compare_revid=None)">
                 stop comparing with revision <tal:b content="python:history.get_revno(compare_revid)" />
               </a>
             </div>
@@ -125,7 +125,7 @@
                 <tr>
                   <th class="filename" colspan="4">
                     <tal:b content="structure python:collapse_button('file', u, 'table-row')" />
-                    <a tal:attributes="href  python:url(['/annotate', change.revid], file_id=item.file_id);
+                    <a tal:attributes="href  python:url(['/annotate', change.revno], file_id=item.file_id);
                                        name  string:${item/filename}-s;
                                        title string:Annotate ${item/filename}"
                        tal:content="item/filename">
@@ -212,7 +212,7 @@
                 <tr>
                   <th class="filename" colspan="4">
                     <tal:b content="structure python:collapse_button('file', u, 'table-row')" />
-                    <a tal:attributes="href  python:url(['/annotate', change.revid], file_id=item.file_id);
+                    <a tal:attributes="href  python:url(['/annotate', change.revno], file_id=item.file_id);
                                        name  string:${item/filename}-u;
                                        title string:Annotate ${item/filename}"
                        tal:content="item/filename">

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2008-05-29 05:58:01 +0000
+++ loggerhead/templates/revisioninfo.pt	2008-06-20 02:13:34 +0000
@@ -28,8 +28,8 @@
       <td class="children">
         <a title="Show history"
            tal:attributes="title string:Show revision ${merge_point/revno};
-                           href python:url(['/revision', merge_point.revid],
-                                           clear=1, start_revid=merge_point.revid)"
+                                        href python:url(['/revision', merge_point.revno], clear=1,
+                                                        start_revid=merge_point.revid)"
            tal:content="python:revno_with_nick(merge_point)">
           ${text}
         </a>
@@ -45,7 +45,7 @@
       <td class="parents">
         <a title="Show history"
            tal:attributes="title string:Show revision ${parent/revno};
-                             href python:url(['/revision', parent.revid], clear=1, start_revid=parent.revid)"
+                           href python:url(['/revision', parent.revno], clear=1, start_revid=parent.revno)"
            tal:content="python:revno_with_nick(parent)">
           class="revlink">
           ${text}
@@ -65,6 +65,17 @@
       </td>
     </tr>
 
+    <tr>
+      <th class="revid">
+        revision id:
+      </th>
+      <td class="revid">
+          <span tal:content="python:change.revid">
+              revid
+        </span>
+      </td>
+    </tr>
+
     <tal:block condition="nocall:modified_file_link">
       <tr class="divider">
         <th>

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2008-06-16 09:41:35 +0000
+++ loggerhead/util.py	2008-06-20 00:57:09 +0000
@@ -356,17 +356,25 @@
 
     navigation.prev_page_revid = get_offset(-1 * navigation.pagesize)
     navigation.next_page_revid = get_offset(1 * navigation.pagesize)
+    prev_page_revno = navigation.branch._history.get_revno(
+            navigation.prev_page_revid)
+    next_page_revno = navigation.branch._history.get_revno(
+            navigation.next_page_revid)
+    start_revno = navigation.branch._history.get_revno(navigation.start_revid)
 
     params = { 'filter_file_id': navigation.filter_file_id }
     if getattr(navigation, 'query', None) is not None:
         params['q'] = navigation.query
-    else:
-        params['start_revid'] = navigation.start_revid
+
+    if getattr(navigation, 'start_revid', None) is not None:
+        params['start_revid'] = start_revno
 
     if navigation.prev_page_revid:
-        navigation.prev_page_url = navigation.branch.url([ navigation.scan_url, navigation.prev_page_revid ], **get_context(**params))
+        navigation.prev_page_url = navigation.branch.context_url(
+            [navigation.scan_url, prev_page_revno], **params)
     if navigation.next_page_revid:
-        navigation.next_page_url = navigation.branch.url([ navigation.scan_url, navigation.next_page_revid ], **get_context(**params))
+        navigation.next_page_url = navigation.branch.context_url(
+            [navigation.scan_url, next_page_revno], **params)
 
 
 def log_exception(log):
@@ -476,6 +484,9 @@
 
 def get_context(**overrides):
     """
+    Soon to be deprecated.
+
+
     return a context map that may be overriden by specific values passed in,
     but only contains keys from the list of valid context keys.
 

